/* TAPE/PVM %W% %G% */

/* event class and module class definitions */

/* a) membership of modules to groups  is defined on the 26 high priority bits */
/*    these bits are usually set by the tape preprocessor. Module groups are   */
/*    identified by capital letters A-Z                                        */

/* b) membership of events to classes is defined on the 6 low priority bits    */
/*    these bits are set by the derouting functions. Event classes are named   */
/*    by lowercase letters                                                     */


#define nb_classe 6

/* PVM event classes */

#define classe_inconnu	0x00
#define classe_control	0x01   /* control class */
#define classe_msg	0x02   /* message class */
#define classe_buffer	0x04   /* buffer handling class */
#define classe_info	0x08   /* info class */
#define classe_syst	0x10   /* system class */
#define classe_group	0x20   /* group class */

#define EC_INCONNU      'u'
#define EC_CONTROL      'c'
#define EC_MSG          'm'
#define EC_INFO         'i'
#define EC_BUFFER       'p'
#define EC_SYST         's'
#define EC_GROUP        'g'

/* user source code module classes */

#define all_modules     0xffffffc0
#define all_types       ~all_modules
